/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
 
#include <avr/io.h>

#include "LCD_alps.h"

char LCD_BUFFER[ ( X_res / X_pix_per_Byte ) * Y_res ];

void LCD_init( void )
{
	
	LCD_PORT |= ( 1<<DI_X ) | ( 1<<CP_X ) | ( 1<<LOAD ) | ( 1<<DI_Y ) | ( 1<<DF ) ;
	LCD_DDR |= ( 1<<DI_X ) | ( 1<<CP_X ) | ( 1<<LOAD ) | ( 1<<DI_Y ) | ( 1<<DF ) ;
	
	
	// LCD-Spannung erzeugen am Ausgang OC2a
	PORTD &= ~(1<<PD7);  // clear port
	DDRD |= (1<<PD7);  // set as output
  
	TCCR2A = ( 0<<WGM21 ) | ( 1<<WGM20 ) | ( 1<<COM2A1 );
	TCCR2B = ( 0<<WGM22 ) | ( 1<<CS20 );
  
	TCNT2=0;
	
	OCR2A=43;
	
	LCD_BUFFER[ 10 ] = 0x01;
}

void LCD_update( void )
{
	static char LCD_DF = 0;
	static char Line = 0;
	static int Pos = 0;
	int i,a;
	unsigned char Data, Temp ;
	
	if ( Line == 0 )
	{
		LCD_PORT |= (1<<LOAD );

		Line = Y_res;

		LCD_PORT &= ~(1<<LOAD );
		
		if ( LCD_DF == 0 )
		{
			LCD_DF = 1;
			LCD_PORT |= ( 1<<DF );
		}
		else
		{
			LCD_DF = 0;
			LCD_PORT &= ~( 1<<DF );
		}

		Pos = 0;

		LCD_PORT |= (1<<DI_Y );
		
	}
	
		
	for( i = 0 ; i < ( X_res / X_pix_per_Byte ) ; i++ )
	{
		Data = LCD_BUFFER[ Pos++ ]; 
		Temp = LCD_PORT;
		for ( a = 0 ; a < X_pix_per_Byte ; a++ )
		{
			// Kieck mal ob MSB 1 ist
			if ( ( Data & 0x80 ) > 0 )
				LCD_PORT = Temp | ( 1<<DI_X ) | ( 1<<CP_X );
			else
				LCD_PORT = Temp & ~( 1<<DI_X )  | ( 1<<CP_X );
			
			Temp = LCD_PORT;
			// SCK auf Low setzen
			LCD_PORT = Temp & ~( 1<<CP_X );
			
			Data <<= 1;
		}
	}


	LCD_PORT |= ( 1<<LOAD );
	LCD_PORT &= ~( 1<<LOAD );

	LCD_PORT &= ~( 1<<DI_Y );
	
	Line--;
	
	return;
}
